#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <vga&bmp.h>

extern unsigned _stklen;

extern int maxx,maxy;                //maximaler Wert fuer X/Y im Grafikmodus
extern int Farbe[20];    // 0-10=Farbe,11-17=Reserviert,siehe auch INI-Datei!
double Puffer[1024];                                //Bildschirm-Daten-Puffer
int PufferMAX;                                //Bildschirm-Daten-Puffer Gre
int wandere=0;                           //kompensiert Wanderlust des Filters


//--------------------------------------------------------------------------
// 0,1,2,3 liest das Signal aus dem Bildschirmspeicher in den Puffer[t],
// Lcken werden entsprechend interpoliert, PufferMAX = Anzahl Pufferwerte!
// -600...4,4...600  mittelt die Pufferwerte: entspricht Tiefpass,Integrator
//--------------------------------------------------------------------------
void Filter(int o)      //0=digital  1=linear  2=sin-Treppe  3=spezial
{                         // 4, 6, 8, 10... 600 = RC-Tiefpass 1.Ordnung
 int a,b,c=0,d=Farbe[1];  //-4,-6,-8,-10...-600 = Integrator-Tiefpass
 double e,f;
 if(o>3)           //4,6,8,10...600=Mittelwert um 'n' Pixel; DSP-Effect!!!
        {
         c=o/2;
         o=o+1;
         for(a=0;a<PufferMAX;a++)
            {
             e=0;
             for(b=0;b<o;b++)
                {
                 d=a+b-c;
                 if(d<0)d+=PufferMAX; //linker Rand
                 if(d>=PufferMAX) d=d%PufferMAX; //rechter Rand
                 e=e+Puffer[d];
                }
             Puffer[a]=e/o;
            }
         return;
        }
 if(o<0)           //-4,-6,-8,-10...-600=Mittelwert um 'n' Pixel;
        {
         o=abs(o);
         if((wandere^=1)==0)
           {
            for(a=0;a<PufferMAX;a++) { e=0; for(b=0;b<o;b++)
                {
                 d=a+b;
                 d=d%PufferMAX;
                 e=e+Puffer[d];
                }
            Puffer[a]=e/o; }
            return;
           }
         else
             {
              for(a=PufferMAX-1;a>=0;a--) { e=0; for(b=0;b<o;b++)
                 {
                  d=a-b;
                  if(d<0) d+=PufferMAX;
                  e=e+Puffer[d];
                 }
             Puffer[a]=e/o; }
             return;
            }
        }

 setcolor(d);
 for(a=0;a<=maxx;a++)Puffer[a]= -100000000.0;
 for(a=0;a<=maxx;a++)
    {
     for(b=0;b<=maxy;b++)if((c=getpixel(a,b))==d)break;  //lese Bildschirm
     if(c==d) { line(a,b,a,maxy); Puffer[a]=(double)b; }
    }
 for(b=maxx;b>1;b--)if(Puffer[b]>=0.0)break; //suche Ende
 for(a=0;a<maxx;a++)if(Puffer[a]>=0.0)break; //suche Anfang
 for(c=a;c<=b;c++)Puffer[c-a]=Puffer[c];     //verschieben
 PufferMAX = b - a + 1;
 if(o==0)                      //digital (hold) Filter
   {
    for(a=0;a<PufferMAX;a++)
       {
        if(Puffer[a]>=0.0)e=Puffer[a]; else Puffer[a]=e;
       }
    return;
   }
 if(o==1)                      //linear Filter
   {
    for(a=0;a<PufferMAX;a++)
       {
        if(Puffer[a]>=0)continue;
        for(b=a;b<PufferMAX;b++)if(Puffer[b]>=0.0)break;
        e=Puffer[b]-Puffer[a-1];
        e=e/( (double)(b-a+1) );
        f=Puffer[b]-e*b;
        for(;a<b;a++)Puffer[a]=e*a+f;
       }
    return;
   }
 if(o==2)                         //sin-Treppe
   {
    for(a=0;a<PufferMAX;a++)
       {
        if(Puffer[a]>=0)continue;
        for(b=a;b<PufferMAX;b++)if(Puffer[b]>=0.0)break;
        a--;
        e=(Puffer[b]-Puffer[a])/2.0;
        f=b-a;
        if(e>0.0)for(c=a;c<=b;c++)Puffer[c]=Puffer[a]+e*(1.0-cos(M_PI*(c-a)/f));
        else for(c=a;c<=b;c++)Puffer[c]=Puffer[a]-e*(cos(M_PI*(c-a)/f)-1.0);
       }
    return;
   }
c=0,d=0;                              //spezial-Filter...
for(a=1;a<PufferMAX;a++)         //linear mit selbstcalibrierendem Tiefpass
   {
    if((Puffer[a-1]>=0.0)&&(Puffer[a]<0.0))d++;
    if(Puffer[a]<0.0)c++;
   }
o=c/d/2;                  //mittlere Interpolationsbreite
if(o<2)o=2;
for(a=0;a<PufferMAX;a++)         //linear Interpolieren
   {
    if(Puffer[a]>=0.0)continue;
    for(b=a;b<PufferMAX;b++)if(Puffer[b]>=0.0)break;
    e=Puffer[b]-Puffer[a-1];
    e=e/( (double)(b-a+1) );
    f=Puffer[b]-e*b;
    for(;a<b;a++)Puffer[a]=e*a+f;
   }
for(a=0;a<PufferMAX;a++)         //tiefpass 1;
   {
    e=0;
    for(b=0;b<o;b++)
       {
        d=a+b;
        if(d>=PufferMAX) d=d%PufferMAX;
        e=e+Puffer[d];
       }
    Puffer[a]=e/o;
   }
for(a=PufferMAX-1;a>=0;a--)     //tiefpass 2;
   {
    e=0;
    for(b=0;b<o;b++)
       {
        d=a-b;
        if(d<0) d+=PufferMAX;
        e=e+Puffer[d];
       }
    Puffer[a]=e/o;
   }
}
