#include <dos.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <alloc.h>
#include <conio.h>

struct REGPACK regp;
union  REGS reg;
FILE *fp;
int i,WritePage=0,minX=0,minY=0,maxx=640,maxy=480,samples=8192,maxe=16384;
double m,t,MaX=16384.0;
double TWO_PI=2.0*M_PI,Dauer;
double huge *real;    //Pointer auf Real - Array
double huge *imag;    //Pointer auf Imag.- Array



void Grafik(int GFXmode)  // 13,      14,     17mono,   18,      19vga,  3
{                         //320x200, 640x200, 640x480, 640x480, 320x200, text
   regp.r_ax = GFXmode;
   intr(0x10,&regp);
}



void Putpixel(int x, int y, int c)
{
 if(x<minX)return;
 if(y<minY)return;
 if(x>=maxx)return;
 if(y>=maxy)return;
 reg.h.ah = 0x0c;
 reg.h.al = c;
 reg.h.bh = WritePage;
 reg.x.cx = x;
 reg.x.dx = y;
 int86(0x10,&reg,&reg);
}



int Getpixel(int x, int y)
{
 if(x<minX)return 0;
 if(y<minY)return 0;
 if(x>=maxx)return 0;
 if(y>=maxy)return 0;
 reg.h.ah = 0x0d;
 reg.h.bh = WritePage;
 reg.x.cx = x;
 reg.x.dx = y;
 int86(0x10,&reg,&reg);
 return reg.h.al;
}



void singlecolor256(int nr,int r,int g,int b)
{
 reg.h.ah = 0x10;
 reg.h.al = 0x10;
 reg.x.bx = nr;
 reg.h.ch = g;
 reg.h.cl = b;
 reg.h.dh = r;
 int86(0x10,&reg,&reg);
}



void singlecolor16(int nr,int r,int g,int b)
{
 reg.h.ah=0x10;
 reg.h.al=0x07;
 reg.h.bl=nr;
 int86(0x10,&reg,&reg);
 nr=reg.h.bh;
 reg.h.ah = 0x10;
 reg.h.al = 0x10;
 reg.x.bx = nr;
 reg.h.ch = g;
 reg.h.cl = b;
 reg.h.dh = r;
 int86(0x10,&reg,&reg);
}



void Visualpage(int p)
{
 reg.h.al = p;
 reg.h.ah = 0x05;
 int86(0x10,&reg,&reg);
}



void TextXYC(int x,int y,int c,char *daten)
{
 int m;
 m=strlen(daten);
 regp.r_ax = 0x1300;
 regp.r_bx = c+256*WritePage;
 regp.r_cx = m;
 regp.r_dx = x+256*y;
 regp.r_es = FP_SEG(daten);
 regp.r_bp = FP_OFF(daten);
 intr(0x10,&regp);
}



//----------------------------------------------------------------------------
/* The program */
//samples = How many Real/Imag Numbers...  = 8192
//power =  log10((double)samples) / log10((double)2.0);  =13 fr 8192 Samples
void fft()
{
	unsigned i1, i2, i3, i4, y;
	int	 loop, loop1, loop2, power=13; //Glckszahl...
	double	 a1, a2, b1, b2, z1, z2, v;

	/* Scale the data */

	for (loop = 0; loop < samples; loop++)  {
		real[loop] /= (double)samples;
		imag[loop] /= (double)samples;
	}

	i1 = samples >> 1;
	i2 = 1;
	v = TWO_PI * ((double)1.0 / (double)samples);

	for (loop = 0; loop < power; loop++)  {
		i3 = 0;
		i4 = i1;

		for (loop1 = 0; loop1 < i2; loop1++)  {
			y = permute(i3 / i1);
			z1 =  cos(v * y);
			z2 = -sin(v * y);

			for (loop2 = i3; loop2 < i4; loop2++)  {
				a1 = real[loop2];
				a2 = imag[loop2];

				b1 = z1*real[loop2+i1] - z2*imag[loop2+i1];
				b2 = z2*real[loop2+i1] + z1*imag[loop2+i1];

				real[loop2]      = a1 + b1;
				imag[loop2]      = a2 + b2;

				real[loop2 + i1] = a1 - b1;
				imag[loop2 + i1] = a2 - b2;
			}

			i3 += (i1 << 1);
			i4 += (i1 << 1);
		}

		i1 >>= 1;
		i2 <<= 1;
	}
}

/*
 *	Bit reverse the number
 *
 *	Change 11100000b to 00000111b or vice-versa
 */

int permute(index)
int	index;
{
	int	n1, result, loop, power=13;  //Glckszahl

	n1 = samples;
	result = 0;

	for (loop = 0; loop < power; loop++)  {
		n1 >>= 1;			/* n1 / 2.0 */
		if (index < n1)
			continue;

		result += ((loop==0)?(1):(1<<loop));
		index -= n1;
	}

	return result;
}

/*
 *	Calculate Power Magnitude
 */

double magnitude(n)
int	n;
{
	n = permute(n);
	return (sqrt(real[n] * real[n] + imag[n] * imag[n]));
}



void inverseFFT()    //von mir!   (Lars Otte)
{
 int j;
 for(j=0;j<samples;j++) imag[j] = -imag[j];
 fft();
 for(j=0;j<samples;j++) imag[j] = -imag[j];
 for(j=0;j<samples;j++) real[j]*=8192.0,imag[j]*=8192.0;
}



void swapping()
{
 int j,h=samples/2;
 double rE,iM;
 for(j=0;j<h;j++)
    {
     rE        = real[j];
     iM        = imag[j];
     real[j]   = real[j+h];
     imag[j]   = imag[j+h];
     real[j+h] = rE;
     imag[j+h] = iM;
    }
}



void unscrambling()   //auch von mir, leider ein Speicherplatzverschwender!
{
 int j,h;
 for(j=0;j<samples;j++)
    {
     h=permute(j);
     real[samples+j] = real[h];
     imag[samples+j] = imag[h];
    }
 for(j=0;j<samples;j++)
    {
     real[j]=real[samples+j];
     imag[j]=imag[samples+j];
    }
}



void multiply()
{
 int i;
 double rE,iM;
 for(i=0;i<samples;i++)
    {
     rE=real[samples+i];  iM=imag[samples+i]; //komplexe Multiplikation
     real[samples+i]=rE*real[i] - iM*imag[i];
     imag[samples+i]=rE*imag[i] + iM*real[i];
    }
}



void interpolate()             //verdoppelt die Auflsung durch Interpolation
{
 int i;
 for(i=0;i<samples;i++)imag[i]=real[i];
 for(i=0;i<samples;i++)real[2*i]=imag[i];
 real[samples*2]=real[0];
 for(i=0;i<samples;i++)real[2*i+1]=(real[2*i]+real[2*i+2])/2.0;
}
//---------------------------------------------------------------------------



void Write(char *name,double amp)
{                                            //AMP ist die max Amplitude fuer
 int t;                                      //die grafische Darstellung
 float f;                                    //NAME = dateiname...
 double d;
 Grafik(18);
 TextXYC(0,0,15,name);
 for(t=0;t<maxx;t++)Putpixel(t,239,1);
 for(t=0;t<maxe;t++)Putpixel(t/25.6,239.0-238.0*(real[t])/amp,2);
 fp=fopen(name,"wb");  if(fp==NULL)return;
 for(t=0;t<maxe;t++) { d=real[t]; f=d; fwrite(&f,4,1,fp); }
 fclose(fp);
 for(t=0;t<16;t++)if(name[t]=='.')break;
 TextXYC(t+2,0,4,"x");
 if(kbhit()) { t=getch(); if(t==27){Grafik(3); exit(0);} }
}



void writeFilter(char *name,double amp)   //Dauer enthlt die Gesamtdauer...
{
 int t;
 long z;
 double d=MaX/Dauer;
 Grafik(18);
 TextXYC(0,0,15,name);
 for(t=0;t<maxy;t++)Putpixel(320,t,1);
 for(t=0;t<maxx;t++)Putpixel(t,239,1);
 for(t=0;t<maxe;t++)Putpixel(t/25.6,239.0-238.0*real[t]/amp,2);
 fp=fopen(name,"wb");  if(fp==NULL)return;
 z=0;                  fwrite(&z,4,1,fp);
 z=16384;              fwrite(&z,4,1,fp);
 z=8192;               fwrite(&z,4,1,fp);
 z=8192;               fwrite(&z,4,1,fp);
 fwrite(&d,8,1,fp);
 for(t=0;t<8192;t++)imag[t]=real[2*t];
 fwrite(imag,8,8192,fp);
 for(t=0;t<8192;t++)imag[t]=real[2*t+1];
 fwrite(imag,8,8192,fp);
 fclose(fp);
 if(kbhit()) { t=getch(); if(t==27){Grafik(3); exit(0);} }
}



void readFilter(char *name)   //Dauer enthlt die neue Gesamtdauer...
{
 long z;
 double d;
 fp=fopen(name,"rb");  if(fp==NULL)return;
 fread(&z,4,1,fp);  fread(&z,4,1,fp);
 fread(&z,4,1,fp);  fread(&z,4,1,fp);
 fread(&d,8,1,fp);  Dauer=2.0*(MaX/d);
 fread(real,8,8192,fp);
 for(z=0;z<8192;z++)real[8192+z]=real[z];
 for(z=0;z<16384;z++)real[z]*=0.5;
 fclose(fp);
}



void Randaufweichen()
{
 long z;
 double d,e;
 for(z=0;z<4096;z++)
    {
     e=0.5-0.5*cos(M_PI*((double)z)/4096.0);
     real[z]*=e;
     real[16384-z]*=e;
    }
}





void main()
{
double far  *Freal;
double far  *Fimag;   /* returned by memory allocation functions */
if((Freal=farcalloc(16385,sizeof(double)))==NULL){printf("out of memory\n"); exit(0);}
if((Fimag=farcalloc(16385,sizeof(double)))==NULL){printf("out of memory\n"); exit(0);}
real=Freal;
imag=Fimag;
Visualpage(WritePage);


printf("\nwriting ZERO.(F) ");
for(i=0;i<maxe;i++)real[i]=0.0,imag[i]=0.0;
fp=fopen("zero.(f)","wb"); if(fp==NULL)return;
fwrite(real,4,maxe,fp);
fwrite(imag,4,maxe,fp);
fclose(fp);


m=(2.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t);
   }
Write("sin.(f)",2.0);


m=(32.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t+1e-99)/(m*t+1e-99);
   }
Write("half_si.(f)",1.0);


m=(64.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;
    real[i]=sin(m*t+1e-99)/(m*t+1e-99);
   }
Write("si.(f)",1.0);


m=(16.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;
    real[i]=pow(sin(m*t+1e-99)/(m*t+1e-99),2.0);
   }
Write("si_m_si.(f)",1.0);


m=(2.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=cos(m*t);
   }
Write("cos.(f)",2.0);


m=(M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t);
   }
Write("half_cos.(f)",1.0);


m=(2.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=0.5-0.5*cos(m*t);
   }
Write("hanning.(f)",1.0);


for(i=0;i<maxe;i++)real[i]=1.0;
Randaufweichen();
Write("hannmix.(f)",2.0);


m=sqrt(8192.0);
for(i=0;i<maxe;i++)
   {
    t=i-8192;
    real[i]=sqrt(8192.0-fabs(t))/m;
   }
Write("wurzel.(f)",1.0);


m=sqrt(8192.0);
for(i=0;i<maxe;i++)
   {
    t=i-8192;
    real[i]=1.0-sqrt(fabs(t))/m;
   }
Write("wurzel2.(f)",1.0);


for(i=0;i<maxe;i++)
   {
    t=i-8192;
    real[i]=1.0-fabs(t)/8192.0;
   }
Write("dreieck.(f)",1.0);


for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=t/MaX;
   }
Write("ramp.(f)",1.0);


for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=fabs(t)/8192.0-1.0;
   }
Write("sgezahn.(f)",2.0);


m=-0.00035;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=exp(m*t);
   }
Write("exp.(f)",1.0);


m=-0.00000007;
for(i=0;i<maxe;i++)
   {
    t=i-8192;
    real[i]=exp(m*t*t);
   }
Write("exp-tt.(f)",1.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0)*sin(m*t);
   }
Randaufweichen();
Dauer=80.0;  writeFilter("!sin-mix.FFT",1.0);


for(i=0;i<maxe;i++)
   {
    if(abs(i-8192)<4096) real[i]=1.0;  else real[i]=0.0;
   }
Dauer=100.0;  writeFilter("!rect.FFT",2.0);
Write("rect.(f)",1.0);


for(i=0;i<maxe;i++)
   {
    if((i&511)==0) real[i]=512.0;  else real[i]=0.0;
   }
Write("diracs.(f)",1024.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0)*(1.0+0.5*cos(m*t));
   }
Write("ampl_m05.(f)",3.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0)*(1.0+cos(m*t));
   }
Write("ampl_m10.(f)",3.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0)*(1.0+2.0*cos(m*t));
   }
Write("ampl_m20.(f)",3.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0)*cos(m*t);
   }
Write("z-s-b_mo.(f)",2.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0+0.7*M_PI*cos(m*t));
   }
Write("phase_m1.(f)",2.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0+M_PI*cos(m*t));
   }
Write("phase_m2.(f)",2.0);


m=(4.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=sin(m*t*10.0+2.0*M_PI*cos(m*t));
   }
Write("phase_m3.(f)",2.0);


for(i=0;i<maxe;i++)
   {
    t=i;   //sgezahn als modulationssignal...
    real[i]=sin((16384.0+t)*m*t/1638.4);
   }
Write("freq_mod.(f)",2.0);


for(i=0;i<maxe;i++)
   {
    t=random(2001)-1000;
    real[i]=t/1000.0;
   }
Write("noise.(f)",1.0);


TextXYC(0,6,14,"Und nun werden die Filter gefaltet, und das kann dauern...");
TextXYC(0,10,14,"dieses Programm >entpackt< die Filter, also bitte etwas Geduld!");
TextXYC(0,20,12,"creating the Filters need some time, please don't press ESC,");
TextXYC(0,24,12,"this Part of FFT4WAVE must only run once, also stay and wait...");
TextXYC(20,15,15,"PRESS a KEY!");
while(kbhit())getch();
i=getch();  Grafik(3);
if(i==27)return;



Dauer=64.0;
m=(Dauer*M_PI)/16384.0;
for(i=0;i<maxe;i++)
   {
    t=i-8192;   t=t*m+1e-66;  imag[i]=0.0;
    real[i]=sin(t)/t;
   }
Randaufweichen();
writeFilter("si_.FFT",1.0);



Dauer=16.0;
m=(Dauer*M_PI)/16384.0;
for(i=0;i<maxe;i++)
   {
    t=i-8192;   t=t*m+1e-66;  imag[i]=0.0;
    real[i]=4.0*sin(0.75*t)*sin(0.25*t)/t/t;
   }
writeFilter("poussin_.FFT",1.0);



Dauer=16.0;
m=(0.5*Dauer*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;  t=t*m+1e-66;
    real[i]=sin(t)/t;
    real[i]*=0.5178*real[i];
   }
Randaufweichen();
writeFilter("fejer_.FFT",1.0);



Dauer=22.0;
m=Dauer/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;  t=t*m+1e-66;
    real[i]=cos(M_PI/2.0*t)/(1.0-t*t);
    real[i]*=(4.0/(M_PI*M_PI)*real[i]);
   }
writeFilter("bohman1_.FFT",1.0);



Dauer=11.0;
m=Dauer/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;  t=t*m+1e-66;
    real[i]=cos(M_PI*t)/(1.0-4.0*t*t);
    real[i]*=(8.0/(M_PI*M_PI)*real[i]);
   }
writeFilter("bohman2_.FFT",1.0);



Dauer=2.0;
m=(Dauer*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i;
    real[i]=0.5-0.5*cos(m*t);
   }
writeFilter("hanning_.FFT",1.0);



Dauer=32.0;
m=(Dauer*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;  t=t*m+1e-9;
    real[i]=0.5*sin(t)/t + 0.25*( sin(t+M_PI)/(t+M_PI) + sin(t-M_PI)/(t-M_PI) );
   }
writeFilter("f-hann1_.FFT",1.0);



Dauer=16.0;
m=(Dauer*2.0*M_PI)/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;  t=t*m+1e-9;
    real[i]=sin(t)/t + 0.5*( sin(t+M_PI)/(t+M_PI) + sin(t-M_PI)/(t-M_PI) );
   }
writeFilter("f-hann2_.FFT",1.0);



Dauer=10.0;
m=Dauer/MaX;
for(i=0;i<maxe;i++)
   {
    t=i-8192;  t=t*m+1e-66;
    real[i]=1.0/sqrt(M_PI)*exp(-t*t);
   }
writeFilter("gauss_.FFT",0.6);



Dauer=2.0004884;
for(i=0;i<maxe;i++)  //rect
   {
    t=abs(i-8192);    real[i]=0.0;
    if(t<4096)real[i]=1.0;
   }
writeFilter("b1splin_.fft",2.0);



Dauer=2.0;
for(i=0;i<maxe;i++)      //dreieck
   {
    t=i-8192;
    real[i]=1.0-fabs(t)/8192.0;
   }
writeFilter("b2splin_.fft",1.0);



Dauer=3.0;
m=3.0/8192.0;
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;  t=fabs(t*m);  imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf("\nFFT ");  swapping();  fft();
for(i=0;i<samples;i++)real[samples+i]=real[i],imag[samples+i]=imag[i]; //up
for(i=0;i<samples;i++)         //rect
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=0.5)real[i]=1.0; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)real[i]=real[samples+i],imag[i]=imag[samples+i]; //down
unscrambling();
printf(" inverseFFT ");  inverseFFT();  unscrambling();  swapping();
m=pow(Dauer,1.0);  for(i=0;i<samples;i++) real[i]*=m;  //korrektur...
interpolate();     writeFilter("b3splin_.fft",1.0);



Dauer=4.0;
m=4.0/8192.0;
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;  t=fabs(t*m);  imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf("\nFFT ");  swapping();  fft();
for(i=0;i<samples;i++)real[samples+i]=real[i],imag[samples+i]=imag[i]; //up
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)real[i]=real[samples+i],imag[i]=imag[samples+i]; //down
unscrambling();
printf(" inverseFFT ");  inverseFFT();  unscrambling();  swapping();
m=pow(Dauer,1.0);  for(i=0;i<samples;i++) real[i]*=m;  //korrektur...
interpolate();     writeFilter("b4splin_.fft",1.0);



Dauer=5.0;
m=5.0/8192.0;
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;  t=fabs(t*m);  imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf("\nFFT ");  swapping();  fft();
for(i=0;i<samples;i++)real[samples+i]=real[i],imag[samples+i]=imag[i]; //up
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)         //rect
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=0.5)real[i]=1.0; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)real[i]=real[samples+i],imag[i]=imag[samples+i]; //down
unscrambling();
printf(" inverseFFT ");  inverseFFT();  unscrambling();  swapping();
m=pow(Dauer,2.0);  for(i=0;i<samples;i++) real[i]*=m;  //korrektur...
interpolate();     writeFilter("b5splin_.fft",1.0);



Dauer=6.0;
m=6.0/8192.0;
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;  t=fabs(t*m);  imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf("\nFFT ");  swapping();  fft();
for(i=0;i<samples;i++)real[samples+i]=real[i],imag[samples+i]=imag[i]; //up
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)real[i]=real[samples+i],imag[i]=imag[samples+i]; //down
unscrambling();
printf(" inverseFFT ");  inverseFFT();  unscrambling();  swapping();
m=pow(Dauer,2.0);  for(i=0;i<samples;i++) real[i]*=m;  //korrektur...
interpolate();     writeFilter("b6splin_.fft",1.0);



Dauer=7.0;
m=7.0/8192.0;
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;  t=fabs(t*m);  imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf("\nFFT ");  swapping();  fft();
for(i=0;i<samples;i++)real[samples+i]=real[i],imag[samples+i]=imag[i]; //up
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)         //rect
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=0.5)real[i]=1.0; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)real[i]=real[samples+i],imag[i]=imag[samples+i]; //down
unscrambling();
printf(" inverseFFT ");  inverseFFT();  unscrambling();  swapping();
m=pow(Dauer,3.0);  for(i=0;i<samples;i++) real[i]*=m;  //korrektur...
interpolate();     writeFilter("b7splin_.fft",1.0);



Dauer=8.0;
m=8.0/8192.0;
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;  t=fabs(t*m);  imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf("\nFFT ");  swapping();  fft();
for(i=0;i<samples;i++)real[samples+i]=real[i],imag[samples+i]=imag[i]; //up
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)         //dreieck
   {
    t=i-4096;   t=fabs(t*m);    imag[i]=0.0;
    if(t<=1.0)real[i]=1.0-t; else real[i]=0.0;
   }
printf(" FFT ");  swapping();  fft();
printf(" multiply ");  multiply();
for(i=0;i<samples;i++)real[i]=real[samples+i],imag[i]=imag[samples+i]; //down
unscrambling();
printf(" inverseFFT ");  inverseFFT();  unscrambling();  swapping();
m=pow(Dauer,3.0);  for(i=0;i<samples;i++) real[i]*=m;  //korrektur...
interpolate();     writeFilter("b8splin_.fft",1.0);



 readFilter("hanning_.fft");
writeFilter("haning__.fft",1.0);

 readFilter("b2splin_.fft");
writeFilter("b2spli__.fft",1.0);

 readFilter("b3splin_.fft");
writeFilter("b3spli__.fft",1.0);

farfree(Freal);
farfree(Fimag);
Grafik(3);
}
