#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <alloc.h>


unsigned char ca;
unsigned short ra;
unsigned long la;
FILE *fp;
unsigned char gstring[80];

unsigned char major;
unsigned char minor;

//.WAV stuff
unsigned long rID;
unsigned long rLen;
unsigned long wID;
unsigned long fID;
unsigned long fLen;
unsigned long fNext;
unsigned short wFormatTag;
unsigned short nChannels;
unsigned short nSamplesPerSec;
unsigned short nAvgBytesPerSec;
unsigned long dID;
unsigned long dLen;


unsigned char *data;
unsigned char *aligned;
unsigned char aligned_physical;

//------------------------------------------------------------------------------
void dspwrite ( unsigned char c )
{
    while(inportb(0x022C)&0x80);
    outportb(0x022C,c);
}
//------------------------------------------------------------------------------
unsigned char dspread ( void )
{
    while(!(inportb(0x22E)&0x80));
    return(inportb(0x22A));
}
//------------------------------------------------------------------------------
void sbinit ( void )
{
    unsigned short x;
    inportb(0x022E);
    outportb(0x0226,0x01);
    inportb(0x0226);
    inportb(0x0226);
    inportb(0x0226);
    inportb(0x0226);
    outportb(0x0226,0x00);
    for(x=0;x<100;x++)
    {
        if(inportb(0x022E)&0x80)
        {
            if(inportb(0x022A)==0xAA) break;
        }
    }
    if(x==100)
    {
        printf("Sound Blaster not found at 0220h\n");
        exit(1);
    }
}
//------------------------------------------------------------------------------
void sbmalloc ( void )
{
    unsigned long physical;
    data=farmalloc(131000L);
    if(data==NULL)
    {
        printf("Memory Allocation Error\n");
        exit(1);
    }
    physical=((unsigned long)FP_OFF(data))+(((unsigned long)FP_SEG(data))<<4);
    physical+=0x0FFFFL;
    physical&=0xF0000L;
    aligned_physical=(physical>>16)&15;
    aligned=MK_FP(((unsigned short)aligned_physical<<12)&0xF000,0);
}
//------------------------------------------------------------------------------
void sbsettc ( unsigned char tc )
// tc = time constant = 256L - (1000000UL/samples per second)
{
    inportb(0x022E);
    dspwrite(0x40);
    dspwrite(tc);
}
//------------------------------------------------------------------------------
void sbrec ( unsigned short len )
// len = number of bytes to record to unsigned char *aligned (<=65000)
{
    len--;
    outportb(0x0A,0x05);
    outportb(0x0C,0x00);
    outportb(0x0B,0x45);
    outportb(0x02,0);
    outportb(0x02,0);
    outportb(0x83,aligned_physical);
    outportb(0x03,(unsigned char)(len&0xFF));
    outportb(0x03,(unsigned char)((len>>8)&0xFF));
    outportb(0x0A,0x01);
    dspwrite(0x24);
    dspwrite((unsigned char)(len&0xFF));
    dspwrite((unsigned char)((len>>8)&0xFF));
}
//------------------------------------------------------------------------------
void sbrec2 ( unsigned short len )
// len = number of bytes to record to unsigned char *aligned (<=65000)
{
    len--;
    outportb(0x0A,0x05);
    outportb(0x0C,0x00);
    outportb(0x0B,0x45);
    outportb(0x02,0);
    outportb(0x02,0);
    outportb(0x83,aligned_physical);
    outportb(0x03,(unsigned char)(len&0xFF));
    outportb(0x03,(unsigned char)((len>>8)&0xFF));
    outportb(0x0A,0x01);
    dspwrite(0x48);
    dspwrite((unsigned char)(len&0xFF));
    dspwrite((unsigned char)((len>>8)&0xFF));
    dspwrite(0x99);
}
//------------------------------------------------------------------------------
unsigned short dmacount ( void )
{
    unsigned short x;
    x=inportb(0x03);
    x|=inportb(0x03)<<8;
    if(x==0xFFFF) inportb(0x022E);
    return(x);
}
//------------------------------------------------------------------------------
unsigned short dmastatus ( void )
{
    return(inportb(0x0008)&2);
}

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------

void main ( int argc, char *argv[] )
{
    if(argc==1)
    {
        printf("MAKEWAVE [d:][path]filename[.WAV] [samplerate]\n");
        exit(1);
    }
    if(argc==2)
    {
        nSamplesPerSec=11000;
        printf("Default sample rate of %u Hz will be used\n",nSamplesPerSec);
    }
    if(argc>=3)
    {
        nSamplesPerSec=atoi(argv[2]);
        printf("Samples Per Second %u\n",nSamplesPerSec);
    }

    strcpy(gstring,argv[1]);
    strcat(gstring,".WAV");
    if((fp=fopen(gstring,"wb"))==0)
    {
        strcpy(gstring,argv[1]);
        if((fp=fopen(gstring,"wb"))==0)
        {
            printf("Error creating .WAV file [%s]\n",argv[1]);
            exit(1);
        }
    }
    printf("FILE: [%s]\n",gstring);
    sbinit();
    dspwrite(0xE1);
    major=dspread();
    minor=dspread();
    printf("DSP version %u.%u\n",major,minor);
    sbmalloc();
    fLen=16;
    wFormatTag=1;
    nChannels=1;
    nAvgBytesPerSec=0;
    dLen=65000;
    rLen=20+fLen+dLen;

    rID=0x46464952;
    fwrite(&rID,1,4,fp);
    fwrite(&rLen,1,4,fp);
    wID=0x45564157;
    fwrite(&wID,1,4,fp);
    fID=0x20746D66;
    fwrite(&fID,1,4,fp);
    fwrite(&fLen,1,4,fp);
    fwrite(&wFormatTag,1,2,fp);
    fwrite(&nChannels,1,2,fp);
    fwrite(&nSamplesPerSec,1,2,fp);
    fwrite(&nAvgBytesPerSec,1,2,fp);
    fwrite(&nSamplesPerSec,1,2,fp);
    ra=0; fwrite(&ra,1,2,fp);
    ra=1; fwrite(&ra,1,2,fp);
    ra=8; fwrite(&ra,1,2,fp);
    dID=0x61746164;
    fwrite(&dID,1,4,fp);
    fwrite(&dLen,1,4,fp);
    ca=(65536L-(256000000L/nSamplesPerSec))>>8;
    printf("Time Constant %u\n",ca);
    sbsettc(ca);
    if(nSamplesPerSec<15000)sbrec(dLen); else sbrec2(dLen);
    printf("Recording %lu samples\n",dLen);
//  while(1) if(dmacount()==0xFFFF) break;
    dmastatus();
    while(!dmastatus()) continue;
    fwrite(aligned,1,dLen,fp);
}
//------------------------------------------------------------------------------
// Copyright (c) David Welch, 1993  (Public Domain)
// modifiyed 1994 by Lars Otte for Highspeedmode ...
//------------------------------------------------------------------------------

